<template>
  <div class="sbosidebar">
    <el-dialog
      :before-close="close"
      destroy-on-close
      width="100%"
      custom-class="sidebar-dialog-gametype"
      v-model="visible"
      :show-close="false"
    >
      <template #title>
        <div class="w-full text-center" @click="close">
          <font-awesome-icon class="text-[25px]" icon="angle-down" />
        </div>
      </template>
      <div class="flex flex-wrap">
        <div
          v-for="gameType in gameTypes"
          :key="gameType"
          class="w-[33.33%] text-center"
        >
          <div
            class="text-white"
            @click="handleProviderClicked(gameType.split(' ').join(''))"
          >
            <div class="py-[10px] px-0">
              <div class="mb-[5px] h-[70px]">
                <SvgIcon class="w-full h-full" :svg-name="gameType
                        .split(' ')
                        .join('').toLocaleLowerCase()" />
              </div>
              <div class="text-center">
                {{ $t(gameType) }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, toRefs } from "vue";
import { useRouter } from "vue-router";
import { store } from "@/store";

export default defineComponent({
  props: {
    gameTypeDialogVisible: {
      type: Boolean,
      required: true,
    },
    handleClick: {
      type: Function,
      required: false,
    },
  },
  emits: ["update:gameTypeDialogVisible"],
  setup(props, { emit }) {
    const { gameTypeDialogVisible: visible } = toRefs(props);
    const { getAssetImage } = commonHelper;
    const router = useRouter();
    const close = () => {
      emit("update:gameTypeDialogVisible", false);
    };
    const handleProviderClicked = (path: string) => {
      emit("update:gameTypeDialogVisible", false);
      router.push(`/games/${path}`);
      props.handleClick?.();
    };
    const gameTypes = computed(
      () => {
        const gameTypeList = [...store.state.gameTabProviderList.SeamlessGameGameTypeList];

        if (!gameTypeList.includes('Favorite')) {
          gameTypeList.push('Favorite');
        }
        return gameTypeList;
      }
    );
    return {
      handleProviderClicked,
      getAssetImage,
      close,
      visible,
      gameTypes,
    };
  },
});
</script>
<style lang="scss">
.sidebar-dialog-gametype.el-dialog {
  max-height: 428.56px;
  background: #082a5c;
  position: absolute;
  bottom: 0;
  .el-dialog__body {
    padding-top: 0;
    overflow: scroll;
    height: 370px;
  }
}
</style>
